class CreateInitialDb < ActiveRecord::Migration[5.1]
  def change
    create_table :blobs, id: :uuid do |t|
      t.timestamps
      t.string :hash
      t.string :body
    end

    create_table :trees, id: :uuid do |t|
      t.timestamps
      t.string :hash
      t.string :body
    end

    create_table :baselines, id: :uuid do |t|
      t.timestamps
      t.string :name
      t.references :tree
    end

    # De-normalization for performance (truth is stored in trees & blobs)
    create_table :tree_blobs, id: :uuid do |t|
      t.timestamps
      t.string :name
      t.references :tree
      t.references :blob
    end

    create_table :tree_trees, id: :uuid do |t|
      t.timestamps
      t.string :name
      t.references :parent, type: :uuid, index: { name: 'tree_trees_parent' }, foreign_key: { to_table: :trees }
      t.references :child, type: :uuid, index: { name: 'tree_trees_child' }, foreign_key: { to_table: :trees }
    end
  end
end